import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.table.*;

/**
  * Direkte Sortier-Algorithmen + QuickSort
  *
  * @version 1.1 vom 11.06.2012
  * @author Roland Mechling
  */

public class sort extends JFrame {
  // Anfang Attribute
  private JTable jTable1 = new JTable(2, 16);
  private DefaultTableModel jTable1Model = (DefaultTableModel) jTable1.getModel();
  private JScrollPane jTable1ScrollPane = new JScrollPane(jTable1);
  private JButton jBtn_Sort = new JButton();
  private JRadioButton jRB_Austausch = new JRadioButton();
  private JRadioButton jRB_Bubble = new JRadioButton();
  private JRadioButton jRB_Auswahl = new JRadioButton();
  private JButton jBtn_Init = new JButton();
  private ButtonGroup jButtonGroup1 = new ButtonGroup();
  private TextArea textOut = new TextArea("", 1, 1, TextArea.SCROLLBARS_VERTICAL_ONLY);
  private JRadioButton jRB_Quick = new JRadioButton();
  // Ende Attribute
  private int[] data = new int[16];   // Arbeits-Array
  private int switchCount = 0;        // Zhler fr Tauschvorgnge
  private int compareCount = 0;       // Zhler fr Vergleiche
  
  
  public sort(String title) {
    // Frame-Initialisierung
    super(title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    int frameWidth = 931; 
    int frameHeight = 225;
    setSize(frameWidth, frameHeight);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2;
    setLocation(x, y);
    setResizable(false);
    Container cp = getContentPane();
    cp.setLayout(null);
    // Anfang Komponenten
    
    jTable1ScrollPane.setBounds(0, 0, 929, 73);
    jTable1.setRowHeight(24);
    for (int i = 0; i < 16 ; i++ ) {
      jTable1.getColumnModel().getColumn(i).setHeaderValue(Integer.toString(i));
    } // end of for
    cp.add(jTable1ScrollPane);
    jBtn_Sort.setBounds(208, 144, 137, 41);
    jBtn_Sort.setText("Sortieren");
    jBtn_Sort.setMargin(new Insets(2, 2, 2, 2));
    jBtn_Sort.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jBtn_Sort_ActionPerformed(evt);
      }
    });
    cp.add(jBtn_Sort);
    
    jRB_Austausch.setBounds(16, 96, 161, 17);
    jRB_Austausch.setText("Austausch-Sortierung");
    jRB_Austausch.setOpaque(false);
    jRB_Austausch.setSelected(true);
    jButtonGroup1.add(jRB_Austausch);
    cp.add(jRB_Austausch);
    
    jRB_Bubble.setBounds(16, 120, 161, 17);
    jRB_Bubble.setText("Bubble-Sortierung");
    jRB_Bubble.setOpaque(false);
    jRB_Bubble.setSelected(false);
    jButtonGroup1.add(jRB_Bubble);
    cp.add(jRB_Bubble);
    
    jRB_Auswahl.setBounds(16, 144, 161, 17);
    jRB_Auswahl.setText("Auswahl-Sortierung");
    jRB_Auswahl.setOpaque(false);
    jButtonGroup1.add(jRB_Auswahl);
    cp.add(jRB_Auswahl);
    
    jRB_Quick.setBounds(16, 168, 161, 17);
    jRB_Quick.setText("Quick-Sort");
    jRB_Quick.setOpaque(false);
    jButtonGroup1.add(jRB_Quick);
    cp.add(jRB_Quick);
    
    jBtn_Init.setBounds(208, 88, 137, 41);
    jBtn_Init.setText("Rcksetzen");
    jBtn_Init.setMargin(new Insets(2, 2, 2, 2));
    jBtn_Init.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jBtn_Init_ActionPerformed(evt);
      }
    });
    cp.add(jBtn_Init);
    
    textOut.setBounds(384, 88, 337, 97);
    cp.add(textOut);
    // Ende Komponenten
    
    setVisible(true);
  } // end of public sort
  
  // Anfang Methoden
  
  private void moveIntsFromArrayToTable(int row) {
    for (int i = 0; i < 16 ; i++ ) {
      String srn = Integer.toString(data[i]);
      jTable1.setValueAt(srn, row, i);
      if (row == 0) {
        jTable1.setValueAt("", 1, i);
      } // end of if
    } // end of for
  }
  
  private boolean compareData(int n, int i) {
    compareCount++;
    return data[n] > data[i];
  }
  
  private boolean isLessThan(int w1, int w2) {
    compareCount++;
    return w1 < w2;
  }
  
  private void switchData(int i, int n) {
    switchCount++;
    int buf = data[i];
    data[i] = data[n];
    data[n] = buf;
  }
  
  private void doAustauschSort() {
    for (int n = 0; n < 15; n++) {
      for (int i = n + 1; i < 16; i++) {
        if (compareData(n, i)) {   // true <==> data[n] > data[i]
          switchData(n, i);
        } // end of if
      } // end of for
    } // end of for
  }
  
  private void doBubbleSort() {
    for (int n = 0; n < 15; n++) {
      for (int i = 15; i > n; i--) {
        if (compareData(n, i)) {   // true <==> data[n] > data[i]
          switchData(n, i);
        } // end of if
      } // end of for
    } // end of for
  }
  
  private void doAuswahlSort() {
    for (int n = 0; n < 15; n++) {
      int min_index = n;
      for (int i = n + 1; i < 16; i++) {
        if (compareData(min_index, i)) {   // true <==> data[min_index] > data[i]
          min_index = i;
        } // end of if
      } // end of for
      if (min_index != n) {
        switchData(min_index, n);
      } // end of if
    } // end of for
  }
  
  /*
  * Achtung! Dieser Algorithmus verwendet als Vergleichsfunktion nicht wie
  * die anderen Algorithmen die boolsche Funktion "compareData()", sondern
  * eine eigene "isLessThan()"-Funktion, die Werte(!) statt Platznummern(!)
  * bergeben bekommt:
  *    IsLessThan(a, b)  == true  <==>        a < b
  *    compareData(a, b) == true  <==>  data[a] > data[b]
  * Dies ermglicht, dass der "mittlere" Vergleichswert v fr den gesamten
  * Durchlauf der untenstehenden do..while - Schleife stets derselbe bleibt,
  * obwohl i oder j ber den "mittleren" Wert [also (li + re) / 2 ] drber-
  * laufen!
  */
  private void qs(int li, int re) {
    int i = li;
    int j = re;
    int v = data[(li + re) / 2];  // v = fr den aktuellen qs-Run fest gewhlter Vergleichswert
    do {
      while (isLessThan(data[i], v)) {
        i = i + 1;
      }
      while (isLessThan(v, data[j])) {
        j = j - 1;
      }
      if (i <= j) {
        switchData(i, j);
        i = i + 1;
        j = j - 1;
      }
    } while (i <= j);
    if (li < j) { qs(li, j); }
    if (i < re) { qs(i, re); }
  }
  
  private void doQuickSort() {
    qs(0, 15);
  }
  
  public void jBtn_Init_ActionPerformed(ActionEvent evt) {
    for (int i = 0; i < 16; i++) {
      int rn = (int) (Math.random() * 100);
      data[i] = rn;
    } // end of for
    moveIntsFromArrayToTable(0);
  } // end of jBtn_Init_ActionPerformed
  
  public void jBtn_Sort_ActionPerformed(ActionEvent evt) {
    switchCount = 0;
    compareCount = 0;
    if (jRB_Austausch.isSelected()) {
      doAustauschSort();
    } else if (jRB_Bubble.isSelected()) {
      doBubbleSort();
    } else if (jRB_Auswahl.isSelected()) {
      doAuswahlSort();
    } else if (jRB_Quick.isSelected()) {
      doQuickSort();
    } // end of if
    moveIntsFromArrayToTable(1);
    textOut.append(Integer.toString(compareCount) + " Vergleiche,  " +
    Integer.toString(switchCount)  + " Tauschvorgnge \n");
  } // end of jBtn_Sort_ActionPerformed
  
  public String getSelectedRadioButton(ButtonGroup bg) {
    for (java.util.Enumeration<AbstractButton> e = bg.getElements(); e.hasMoreElements();) {
      AbstractButton b = e.nextElement();
      if (b.isSelected()) return b.getText();
    }
    return null;
  }
  
  // Ende Methoden
  
  public static void main(String[] args) {
    new sort("Vergleich von Sortieralgorithmen");
  } // end of main
  
} // end of class sort
